!!NVgp4.0

# thick lines shader

PRIMITIVE_IN LINES;
PRIMITIVE_OUT TRIANGLE_STRIP;
VERTICES_OUT 4;

TEMP v0, v1, v2, v3;
TEMP d;
PARAM width = 0.1;

# calculate orthogonal vector
MOV d, 0.0;
SUB d.xy, vertex[1].position, vertex[0].position;
NRM d, d;
MUL d.xy, d.yxxx, { -1, 1 };

# compute new vertices
MAD v0, d, -width, vertex[0].position;
MAD v1, d, width, vertex[0].position;
MAD v2, d, width, vertex[1].position;
MAD v3, d, -width, vertex[1].position;

MOV result.color, vertex[0].color;
MOV result.position, v0;
EMIT;
MOV result.color, vertex[0].color;
MOV result.position, v1;
EMIT;
MOV result.color, vertex[1].color;
MOV result.position, v3;
EMIT;
MOV result.color, vertex[1].color;
MOV result.position, v2;
EMIT;
END