!!NVgp4.0

# geometry program to subdivide a triangle into 4 triangles

PRIMITIVE_IN TRIANGLES;
PRIMITIVE_OUT TRIANGLE_STRIP;
VERTICES_OUT 8;

ATTRIB v0 = vertex[0].position;
ATTRIB v1 = vertex[1].position;
ATTRIB v2 = vertex[2].position;
TEMP m0, m1, m2;

# compute midpoints
ADD m0, v0, v1;
MUL m0, m0, 0.5;
ADD m1, v1, v2;
MUL m1, m1, 0.5;
ADD m2, v2, v0;
MUL m2, m2, 0.5;

# output 3 triangles as triangle strip
MOV result.position, v0; EMIT;
MOV result.position, m2; EMIT;
MOV result.position, m0; EMIT;
MOV result.position, m1; EMIT;
MOV result.position, v1; EMIT;
ENDPRIM;

# output 4th triangle
MOV result.position, v2; EMIT;
MOV result.position, m1; EMIT;
MOV result.position, m2; EMIT;
ENDPRIM;

END