!!NVgp4.0

# wiggle geometry program

PRIMITIVE_IN LINES;
PRIMITIVE_OUT LINE_STRIP;
VERTICES_OUT 100;
PARAM segments = program.local[0];
PARAM mvp[4] = { state.matrix.mvp };
PARAM freq = 12.566;
PARAM width = 0.05;
TEMP pos, t, dt, temp;
TEMP d;

MOV d, 0.0;
SUB d.xy, vertex[1].position, vertex[0].position;
NRM d, d;
MUL d.xy, d.yxxx, { -1, 1 };

DIV dt.x, 1.0, segments.x;
MOV t.x, 0.0;
ADD temp.x, segments.x, 1;

REP temp.x;

LRP pos, t.x, vertex[0].position, vertex[1].position;
MUL temp.x, t.x, freq;
SIN temp.x, temp.x;
MUL temp.x, temp, width;
MAD pos.xy, d, temp.x, pos;

#MOV result.color, t.xxxx;
MOV result.color, vertex[0].color;
MOV result.position, pos;
EMIT;

ADD t, t, dt;

ENDREP;

END